/* USER Mmdification to accept any URL address (HYPERLINKs and LABELs)
   Last revised on Novem,ber 22nd, 2016 by Pablo Csar
 */

*************
* HYPERLINKs
*************

#xcommand @ <row>,<col> MYHYPERLINK <name>   ;
    [ <dummy1: OF, PARENT> <parent> ] ;
    [ VALUE <value> ]   ;
    [ ADDRESS <address> ];
    [ WIDTH <width> ]   ;
    [ HEIGHT <height> ]   ;
    [ <autosize : AUTOSIZE> ] ;
    [ FONT <fontname> ]   ;
    [ SIZE <fontsize> ]   ;
    [ <bold : BOLD> ] ;
    [ <italic : ITALIC> ] ;
    [ TOOLTIP <tooltip> ] ;
    [ BACKCOLOR <backcolor> ] ;
    [ <dummy2 : FONTCOLOR> <fontcolor> ] ;
    [ <border: BORDER> ] ;
    [ <clientedge: CLIENTEDGE> ] ;
    [ <transparent: TRANSPARENT> ] ;
    [ <handcursor: HANDCURSOR> ] ;
    [ <rightalign: RIGHTALIGN> ]    ;
    [ <centeralign: CENTERALIGN> ]  ;
    [ HELPID <helpid> ]         ;
    [ <invisible: INVISIBLE> ] ;
    [ <mycorrection: MYCORRECTION> ] ;
 =>;
_DefineLabel (      ;
    <"name">,    ;
    <"parent">,    ;
    <col>,     ;
    <row>,     ;
    <value>,    ;
    <width>,    ;
    <height>,    ;
    <fontname>,    ;
    <fontsize>,    ;
    <.bold.>,    ;
    <.border.> ,   ;
    <.clientedge.> ,  ;
    .f. ,   ;
    .f. ,   ;
    <.transparent.> ,   ;
    [ <backcolor> ], ;
    if ( ! <.dummy2.> , { 0 , 0 , 255 } , <fontcolor> ) , ;
    if ( '@' $ ( <address> ) , {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler mailto:" + <address> , ,1)} , {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler " + <address> , ,1)} )  ,  ;
    <tooltip>,  ;
    <helpid>, ;
    <.invisible.>, ;
    <.italic.>, ;
    .t., ;
    .f. , ;
    <.autosize.> , ;
    <.rightalign.> , ;
    <.centeralign.> ) ;;
    if ( <.handcursor.> , INITHYPERLINKCURSOR ( GetControlhandle ( <"name"> , if ( !empty(_HMG_SYSDATA \[ 223 \]) , _HMG_SYSDATA \[ 223 \] , <"parent"> ) ) ) , _DUMMY() );;
    if ( <.mycorrection.> , MySetAddressControlProcedure( <"name">, <address> ), _DUMMY() )


*************
* LABELs
*************

#xcommand @ <row>,<col> LABEL <name>   ;
    [ <dummy1: OF, PARENT> <parent> ] ;
    [ VALUE <value> ]   ;
    [ ACTION <action> ] ;
    [ WIDTH <width> ]   ;
    [ HEIGHT <height> ]   ;
    [ <autosize : AUTOSIZE> ] ;
    [ FONT <fontname> ]   ;
    [ SIZE <fontsize> ]   ;
    [ <bold : BOLD> ] ;
    [ <italic : ITALIC> ] ;
    [ <underline : UNDERLINE> ] ;
    [ <strikeout : STRIKEOUT> ] ;
    [ TOOLTIP <tooltip> ] ;
    [ BACKCOLOR <backcolor> ] ;
    [ FONTCOLOR <fontcolor> ] ;
    [ <border: BORDER> ] ;
    [ <clientedge: CLIENTEDGE> ] ;
    [ <hscroll: HSCROLL> ] ;
    [ <vscroll: VSCROLL> ] ;
    [ <transparent: TRANSPARENT> ] ;
    [ <rightalign: RIGHTALIGN> ]    ;
    [ <centeralign: CENTERALIGN> ]  ;
    [ HELPID <helpid> ]         ;
    [ <invisible: INVISIBLE> ] ;
    [ <EndEllipses: ENDELLIPSES> ] ;
    [ <NoPrefix: NOPREFIX> ] ;
    [ <mycorrection: MYCORRECTION> ] ;
    =>;
    _DefineLabel (      ;
    <"name">,    ;
    <"parent">,    ;
    <col>,     ;
    <row>,     ;
    <value>,    ;
    <width>,    ;
    <height>,    ;
    <fontname>,    ;
    <fontsize>,    ;
    <.bold.>,    ;
    <.border.> ,   ;
    <.clientedge.> ,  ;
    <.hscroll.> ,   ;
    <.vscroll.> ,   ;
    <.transparent.> ,   ;
    [ <backcolor> ], ;
    [ <fontcolor> ], ;
    <{action}>, ;
    <tooltip>,  ;
    <helpid>, ;
    <.invisible.>, ;
    <.italic.>, ;
    <.underline.>, ;
    <.strikeout.> , ;
    <.autosize.> , ;
    <.rightalign.> , ;
    <.centeralign.>, ;
    <.EndEllipses.>, ;
    <.NoPrefix.> ) ;;
    if ( <.mycorrection.> , MySetAddressControlProcedure( <"name">, <action> ), _DUMMY() )
